/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-basic-states-skill-msgs-0.0.1-0raring-20150414-0716/msg/CurrentState.msg
 *
 */


#ifndef BASIC_STATES_SKILL_MSGS_MESSAGE_CURRENTSTATE_H
#define BASIC_STATES_SKILL_MSGS_MESSAGE_CURRENTSTATE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace basic_states_skill_msgs
{
template <class ContainerAllocator>
struct CurrentState_
{
  typedef CurrentState_<ContainerAllocator> Type;

  CurrentState_()
    : last_update()
    , state()  {
    }
  CurrentState_(const ContainerAllocator& _alloc)
    : last_update()
    , state(_alloc)  {
    }



   typedef ros::Time _last_update_type;
  _last_update_type last_update;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _state_type;
  _state_type state;




  typedef boost::shared_ptr< ::basic_states_skill_msgs::CurrentState_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::basic_states_skill_msgs::CurrentState_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct CurrentState_

typedef ::basic_states_skill_msgs::CurrentState_<std::allocator<void> > CurrentState;

typedef boost::shared_ptr< ::basic_states_skill_msgs::CurrentState > CurrentStatePtr;
typedef boost::shared_ptr< ::basic_states_skill_msgs::CurrentState const> CurrentStateConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::basic_states_skill_msgs::CurrentState_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::basic_states_skill_msgs::CurrentState_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace basic_states_skill_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'basic_states_skill_msgs': ['/tmp/buildd/ros-hydro-basic-states-skill-msgs-0.0.1-0raring-20150414-0716/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::basic_states_skill_msgs::CurrentState_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::basic_states_skill_msgs::CurrentState_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::basic_states_skill_msgs::CurrentState_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::basic_states_skill_msgs::CurrentState_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::basic_states_skill_msgs::CurrentState_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::basic_states_skill_msgs::CurrentState_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::basic_states_skill_msgs::CurrentState_<ContainerAllocator> >
{
  static const char* value()
  {
    return "498f846c5c9a10a2270e6fdc36cb2cac";
  }

  static const char* value(const ::basic_states_skill_msgs::CurrentState_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x498f846c5c9a10a2ULL;
  static const uint64_t static_value2 = 0x270e6fdc36cb2cacULL;
};

template<class ContainerAllocator>
struct DataType< ::basic_states_skill_msgs::CurrentState_<ContainerAllocator> >
{
  static const char* value()
  {
    return "basic_states_skill_msgs/CurrentState";
  }

  static const char* value(const ::basic_states_skill_msgs::CurrentState_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::basic_states_skill_msgs::CurrentState_<ContainerAllocator> >
{
  static const char* value()
  {
    return "#\n\
# Contain the current basic state and the time when launch\n\
#\n\
\n\
time last_update\n\
string state\n\
";
  }

  static const char* value(const ::basic_states_skill_msgs::CurrentState_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::basic_states_skill_msgs::CurrentState_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.last_update);
      stream.next(m.state);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct CurrentState_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::basic_states_skill_msgs::CurrentState_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::basic_states_skill_msgs::CurrentState_<ContainerAllocator>& v)
  {
    s << indent << "last_update: ";
    Printer<ros::Time>::stream(s, indent + "  ", v.last_update);
    s << indent << "state: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.state);
  }
};

} // namespace message_operations
} // namespace ros

#endif // BASIC_STATES_SKILL_MSGS_MESSAGE_CURRENTSTATE_H
